commit 59c6831682dfa8bec2b5a62bdc85739924970808
Author: Patrick Palka <ppalka@redhat.com>
Date:   Tue Sep 14 17:22:12 2021

    c++: empty union member activation during constexpr [PR102163]
    
    Here, the union's constructor is defined to activate its empty data
    member _M_rest, but during constexpr evaluation of this constructor the
    subobject constructor call O::O(&_M_rest, 42) doesn't produce a side
    effect that actually activates the member, so the union still appears
    uninitialized after its constructor has run.  This patch fixes this by
    using a dummy MODIFY_EXPR in this situation, whose evaluation ensures
    the member gets activated.
    
            PR c++/102163
    
    gcc/cp/ChangeLog:
    
            * constexpr.c (cxx_eval_call_expression): After evaluating a
            subobject constructor call for an empty union member, produce a
            side effect that makes sure the member gets activated.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/cpp0x/constexpr-empty17.C: New test.
    
    (cherry picked from commit de07cff96abd43f6f65dcf333958899c2ec42598)

diff --git a/gcc/cp/constexpr.c b/gcc/cp/constexpr.c
index cd81c7edb11..f44def5d955 100644
--- a/gcc/cp/constexpr.c
+++ b/gcc/cp/constexpr.c
@@ -2766,12 +2766,34 @@ cxx_eval_call_expression (const constexpr_ctx *ctx, tree t,
 					&jump_target);
 
 	  if (DECL_CONSTRUCTOR_P (fun))
-	    /* This can be null for a subobject constructor call, in
-	       which case what we care about is the initialization
-	       side-effects rather than the value.  We could get at the
-	       value by evaluating *this, but we don't bother; there's
-	       no need to put such a call in the hash table.  */
-	    result = lval ? ctx->object : ctx->ctor;
+	    {
+	      /* This can be null for a subobject constructor call, in
+		 which case what we care about is the initialization
+		 side-effects rather than the value.  We could get at the
+		 value by evaluating *this, but we don't bother; there's
+		 no need to put such a call in the hash table.  */
+	      result = lval ? ctx->object : ctx->ctor;
+
+	      /* If we've just evaluated a subobject constructor call for an
+		 empty union member, it might not have produced a side effect
+		 that actually activated the union member.  So produce such a
+		 side effect now to ensure the union appears initialized.  */
+	      if (!result && new_obj
+		  && TREE_CODE (new_obj) == COMPONENT_REF
+		  && TREE_CODE (TREE_TYPE
+				(TREE_OPERAND (new_obj, 0))) == UNION_TYPE
+		  && is_really_empty_class (TREE_TYPE (new_obj),
+					    /*ignore_vptr*/false))
+		{
+		  tree activate = build2 (MODIFY_EXPR, TREE_TYPE (new_obj),
+					  new_obj,
+					  build_constructor (TREE_TYPE (new_obj),
+							     NULL));
+		  cxx_eval_constant_expression (ctx, activate, lval,
+						non_constant_p, overflow_p);
+		  ggc_free (activate);
+		}
+	    }
 	  else if (VOID_TYPE_P (TREE_TYPE (res)))
 	    result = void_node;
 	  else
diff --git a/gcc/testsuite/g++.dg/cpp0x/constexpr-empty17.C b/gcc/testsuite/g++.dg/cpp0x/constexpr-empty17.C
new file mode 100644
index 00000000000..86126dabdbb
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp0x/constexpr-empty17.C
@@ -0,0 +1,21 @@
+// PR c++/102163
+// { dg-do compile { target c++11 } }
+
+struct O {
+  constexpr O(int) { }
+};
+
+union _Variadic_union {
+  constexpr _Variadic_union(int __arg) : _M_rest(__arg) { }
+  int _M_first;
+  O _M_rest;
+};
+
+constexpr _Variadic_union u(42);
+
+struct _Variant_storage {
+  constexpr _Variant_storage() : _M_u(42) {}
+  _Variadic_union _M_u;
+};
+
+constexpr _Variant_storage w;

